gstreamermm: Gst::Discoverer Class Reference

gstreamermm 1.4.3

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gst::Discoverer Class Reference

Discoverer - Utility for discovering information on URIs. More...

Inheritance diagram for Gst::Discoverer:
[legend]
Collaboration diagram for Gst::Discoverer:
[legend]

## Public Member Functions
virtual | ~Discoverer ()
GstDiscoverer* | gobj ()
| Provides access to the underlying C GObject. More...
const GstDiscoverer* | gobj () const
| Provides access to the underlying C GObject. More...
GstDiscoverer* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | start ()
| Allow asynchronous discovering of URIs to take place. More...
void | stop ()
| Stop the discovery of any pending URIs and clears the list of pending URIS (if any). More...
Glib::RefPtr< DiscovererInfo > | discover_uri (const Glib::ustring& uri)
| Synchronously discovers the given uri. More...
bool | discover_uri_async (const Glib::ustring& uri)
| Appends the given uri to the list of URIs to discoverer. More...
Glib::PropertyProxy< guint64 > | property_timeout ()
| Timeout. More...
Glib::PropertyProxy_ReadOnly < guint64 > | property_timeout () const
| Timeout. More...
Glib::SignalProxy2< void, const Glib::RefPtr < DiscovererInfo >&, const Glib::Error& > | signal_discovered ()
Glib::SignalProxy0< void > | signal_finished ()
Glib::SignalProxy0< void > | signal_starting ()

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Discoverer > | create (ClockTime timeout)
| Creates a new Gst::Discoverer with the provided timeout. More...

## Protected Member Functions
| Discoverer (ClockTime timeout)
virtual void | on_discovered (const Glib::RefPtr< DiscovererInfo >& info, const Glib::Error& error)
| This is a default handler for the signal signal_discovered(). More...
virtual void | on_finished ()
| This is a default handler for the signal signal_finished(). More...
virtual void | on_starting ()
| This is a default handler for the signal signal_starting(). More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gst::Discoverer > | wrap (GstDiscoverer* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

Discoverer - Utility for discovering information on URIs.

The Discoverer is a utility object which allows to get as much information as possible from one or many URIs.

It provides two APIs, allowing usage in blocking or non-blocking mode.

The blocking mode just requires calling discover_uri() with the URI one wishes to discover.

The non-blocking mode requires a running Glib::MainLoop in the default Glib::MainContext, where one connects to the various signals, appends the URIs to be processed (through discover_uri_async()) and then asks for the discovery to begin (through start()).

All the information is returned in a DiscovererInfo structure.

## Constructor & Destructor Documentation

virtual Gst::Discoverer::~Discoverer | ( |  | ) |
| virtual

Gst::Discoverer::Discoverer | ( | ClockTime | timeout | ) |
| explicitprotected

## Member Function Documentation

static Glib::RefPtr<Discoverer> Gst::Discoverer::create | ( | ClockTime | timeout | ) |
| static

Creates a new Gst::Discoverer with the provided timeout.

Parameters

  timeout | Timeout per file, in nanoseconds. Allowed are values between one second (Gst::SECOND) and one hour (3600* Gst::SECOND).
  err | A pointer to a Error. can be `0`.

Returns
  The new Gst::Discoverer. If an error occurred when creating the discoverer, err will be set accordingly and `0` will be returned. If err is set, the caller must free it when no longer needed using Glib::error_free().

Glib::RefPtr<DiscovererInfo> Gst::Discoverer::discover_uri | ( | const Glib::ustring & | uri | ) |

Synchronously discovers the given uri.

A copy of uri will be made internally, so the caller can safely Glib::free() afterwards.

Parameters

  uri | The URI to run on.
  err | If an error occurred, this field will be filled in.

Returns
  The result of the scanning. Can be `0` if an error occurred.

bool Gst::Discoverer::discover_uri_async | ( | const Glib::ustring & | uri | ) |

Appends the given uri to the list of URIs to discoverer.

The actual discovery of the uri will only take place if start() has been called.

A copy of uri will be made internally, so the caller can safely Glib::free() afterwards.

Parameters

  uri | The URI to add.

Returns
  `true` if the uri was successfully appended to the list of pending uris, else `false`.

static GType Gst::Discoverer::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GstDiscoverer* Gst::Discoverer::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GstDiscoverer* Gst::Discoverer::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GstDiscoverer* Gst::Discoverer::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

virtual void Gst::Discoverer::on_discovered | ( | const Glib::RefPtr< DiscovererInfo >& | info,
|  | const Glib::Error & | error
| ) |  |
| protectedvirtual

This is a default handler for the signal signal_discovered().

virtual void Gst::Discoverer::on_finished | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_finished().

virtual void Gst::Discoverer::on_starting | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_starting().

Glib::PropertyProxy< guint64 > Gst::Discoverer::property_timeout | ( |  | ) |

Timeout.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< guint64 > Gst::Discoverer::property_timeout | ( |  | ) | const

Timeout.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::SignalProxy2< void,const Glib::RefPtr<DiscovererInfo>&,const Glib::Error& > Gst::Discoverer::signal_discovered | ( |  | ) |

Slot Prototype:
  `void on_my_discovered(const Glib::RefPtr<DiscovererInfo>& info, const Glib::Error& error)`

Will be emitted in async mode when all information on a URI could be discovered, or an error occurred.

When an error occurs, info might still contain some partial information, depending on the circumstances of the error.

Parameters

  info | The results Gst::DiscovererInfo.

Glib::SignalProxy0< void > Gst::Discoverer::signal_finished | ( |  | ) |

Slot Prototype:
  `void on_my_finished()`

Will be emitted in async mode when all pending URIs have been processed.

Glib::SignalProxy0< void > Gst::Discoverer::signal_starting | ( |  | ) |

Slot Prototype:
  `void on_my_starting()`

Will be emitted when the discover starts analyzing the pending URIs

void Gst::Discoverer::start | ( |  | ) |

Allow asynchronous discovering of URIs to take place.

A MainLoop must be available for Gst::Discoverer to properly work in asynchronous mode.

void Gst::Discoverer::stop | ( |  | ) |

Stop the discovery of any pending URIs and clears the list of pending URIS (if any).

## Friends And Related Function Documentation

Glib::RefPtr< Gst::Discoverer > wrap | ( | GstDiscoverer * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gstreamermm/discoverer.h